//---------------------------------------------------------------------------
#include <vcl.h>
#include <inifiles.hpp>
#include <stdio.h>
#include <stdlib.h>
#include <shellapi.hpp>
#pragma hdrstop

#include "Unit1.h"
#include "Unit2.h"
#include "Unit3.h"
#include "Unit4.h"
#include "Unit5.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::NewButtonClick(TObject *Sender)
{
 New1->Click();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::OpenButtonClick(TObject *Sender)
{
 Open1->Click();        
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SaveButtonClick(TObject *Sender)
{
 Save1->Click();        
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CheckButtonClick(TObject *Sender)
{
 Check1->Click();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::PaintButtonClick(TObject *Sender)
{
 Paint1->Click();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::MarkButtonClick(TObject *Sender)
{
 Mark1->Click();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::EraseButtonClick(TObject *Sender)
{
 Erase1->Click();        
}
//---------------------------------------------------------------------------
void __fastcall TForm1::MeasureButtonClick(TObject *Sender)
{
 Measure1->Click();        
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ZoominButtonClick(TObject *Sender)
{
 ZoomIn1->Click();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ZoomoutButtonClick(TObject *Sender)
{
 ZoomOut1->Click();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::New1Click(TObject *Sender)
{
 if(ai) ai->Stop();
 OpenDialog1->Title="Open new game";
 OpenDialog1->DefaultExt="jc";
 OpenDialog1->Filter="Japan Crossword (*.jc)|*.jc";
 OpenDialog1->InitialDir=".\\games";
 OpenDialog1->FileName=ChangeFileExt(File,".jc");
 if(OpenDialog1->Execute())
 {
  FILE* f;
  f=fopen(OpenDialog1->FileName.c_str(),"rb");
  if(!f)
  {
   Application->MessageBox("Can't open file","Error",MB_ICONERROR);
   return;
  }
  char id[5];
  fread(id,4,1,f);
  id[4]=0;
  if(strcmp(id,"\x03JCS"))
  {
   Application->MessageBox("Wrong file format","Error",MB_ICONERROR);
   return;
  }
  fread(&sizeX,2,1,f);
  fread(&sizeY,2,1,f);
  if(pattern) delete [] pattern;
  pattern=new char [sizeX*sizeY];
  if(picture) delete [] picture;
  picture=new char [sizeX*sizeY];
  memset(picture,0,sizeX*sizeY);
  if(headX) delete [] headX;
  headX=new char [sizeY];
  memset(headX,1,sizeY);
  if(headY) delete [] headY;
  headY=new char [sizeX];
  memset(headY,1,sizeX);
  if(!fread(pattern,sizeX*sizeY,1,f))
  {
   Application->MessageBox("Can't read file","Error",MB_ICONERROR);
   return;
  }
  fclose(f);
  makegrid();
  File=ExtractFileName(OpenDialog1->FileName);
  Caption=File+" - Japan Crossword";
  saved=true;
  DeleteUndo();
 }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
 Application->OnIdle=AppIdle;
 ZoomIn1->ShortCut=107;
 ZoomOut1->ShortCut=109;
 sizeX=0;
 sizeY=0;
 pattern=NULL;
 picture=NULL;
 headX=NULL;
 headY=NULL;
 numX=NULL;
 numY=NULL;
 tool=1;
 TIniFile* Ini=new TIniFile(".\\Japan.ini");
 paintshape.Shape=Ini->ReadInteger("Options","PaintShape",0);
 paintshape.Color=StringToColor(Ini->ReadString("Options","PaintColor","clRed"));
 markshape.Shape=Ini->ReadInteger("Options","MarkShape",0);
 markshape.Color=StringToColor(Ini->ReadString("Options","MarkColor","clBlue"));
 MainGrid->DefaultColWidth=Ini->ReadInteger("Position","Size",15);
 MainGrid->DefaultRowHeight=MainGrid->DefaultColWidth;
 resize();
 int tmp;
 tmp=Ini->ReadInteger("Position","Buttons",0);
 if(tmp<CoolBar->Bands->Count)
 {
  CoolBar->Bands->Items[tmp]->Control=ButtonPanel;
  CoolBar->Bands->Items[tmp]->MinHeight=ButtonPanel->Height;
 }
 tmp=Ini->ReadInteger("Position","MainGrid",1);
 if(tmp<CoolBar->Bands->Count)
 {
  CoolBar->Bands->Items[tmp]->Control=MainGrid;
  CoolBar->Bands->Items[tmp]->MinHeight=MainGrid->Height;
 }
 tmp=Ini->ReadInteger("Position","Status",2);
 if(tmp<CoolBar->Bands->Count)
 {
  CoolBar->Bands->Items[tmp]->Control=StatusPanel;
  CoolBar->Bands->Items[tmp]->MinHeight=StatusPanel->Height;
 }

 delete Ini;
 saved=true;
 randomize();
 ai=NULL;
 undoBuf=NULL;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormDestroy(TObject *Sender)
{
 TIniFile* Ini=new TIniFile(".\\Japan.ini");
 Ini->WriteInteger("Options","PaintShape",paintshape.Shape);
 Ini->WriteString("Options","PaintColor",ColorToString(paintshape.Color));
 Ini->WriteInteger("Options","MarkShape",markshape.Shape);
 Ini->WriteString("Options","MarkColor",ColorToString(markshape.Color));
 for(int i=0;i<CoolBar->Bands->Count;i++)
 {
  if(CoolBar->Bands->Items[i]->Control==ButtonPanel)
   Ini->WriteInteger("Position","Buttons",i);
  else if(CoolBar->Bands->Items[i]->Control==MainGrid)
   Ini->WriteInteger("Position","MainGrid",i);
  else if(CoolBar->Bands->Items[i]->Control==StatusPanel)
   Ini->WriteInteger("Position","Status",i);
 }
 Ini->WriteInteger("Position","Size",MainGrid->DefaultColWidth);
 Ini->UpdateFile();
 delete Ini;
 if(pattern) delete [] pattern;
 if(picture) delete [] picture;
 if(headX) delete [] headX;
 if(headY) delete [] headY;
 if(numX) delete [] numX;
 if(numY) delete [] numY;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Exit1Click(TObject *Sender)
{
 Close();
}
//---------------------------------------------------------------------------
void TForm1::makegrid()
{
 //memcpy(picture,pattern,sizeX*sizeY);
 MainGrid->ColCount=sizeX;
 MainGrid->RowCount=sizeY;
 MainGrid->FixedCols=0;
 MainGrid->FixedRows=0;
 SizeLabel->Caption=IntToStr(sizeX)+'x'+IntToStr(sizeY);
 int i,j;
 int g;
 int max;
 char pre;
 max=0;
 for(j=0;j<sizeY;j++)
 {
  g=0;
  pre=0;
  for(i=0;i<sizeX;i++)
  {
   if(!pre&&pattern[i+j*sizeX])
    g++;
   pre=pattern[i+j*sizeX];
  }
  if(g>max) max=g;
 }
 MainGrid->ColCount+=max;
 MainGrid->FixedCols+=max;
 max=0;
 for(i=0;i<sizeX;i++)
 {
  g=0;
  pre=0;
  for(j=0;j<sizeY;j++)
  {
   if(!pre&&pattern[i+j*sizeX])
    g++;
   pre=pattern[i+j*sizeX];
  }
  if(g>max) max=g;
 }
 MainGrid->RowCount+=max;
 MainGrid->FixedRows+=max;
 if(numX) delete [] numX;
 numX=new char [MainGrid->FixedCols*sizeY];
 memset(numX,0,MainGrid->FixedCols*sizeY);
 if(numY) delete [] numY;
 numY=new char [MainGrid->FixedRows*sizeX];
 memset(numY,0,MainGrid->FixedRows*sizeX);
 for(j=0;j<sizeY;j++)
 {
  pre=0;
  g=MainGrid->FixedCols-1;
  for(i=sizeX-1;i>=0;i--)
  {
   if(pattern[i+j*sizeX])
    numX[j+g*sizeY]++;
   if(!pattern[i+j*sizeX]&&pre)
    g--;
   pre=pattern[i+j*sizeX];
  }
 }
 for(i=0;i<sizeX;i++)
 {
  pre=0;
  g=MainGrid->FixedRows-1;
  for(j=sizeY-1;j>=0;j--)
  {
   if(pattern[i+j*sizeX])
    numY[i+g*sizeX]++;
   if(!pattern[i+j*sizeX]&&pre)
    g--;
   pre=pattern[i+j*sizeX];
  }
 }
 resize();
}
//---------------------------------------------------------------------------
void TForm1::resize()
{
 int newWidth=MainGrid->ColCount*(MainGrid->DefaultColWidth+MainGrid->GridLineWidth)+4;
 int newHeight=MainGrid->RowCount*(MainGrid->DefaultRowHeight+MainGrid->GridLineWidth)+4;
 for(int i=0;i<CoolBar->Bands->Count;i++)
  CoolBar->Bands->Items[i]->MinWidth=newWidth;
 CoolBar->Width=newWidth+13; 
 //ControlBar->Width=newWidth+13;
 //ControlBar->Constraints->MinHeight = newHeight+4+ButtonPanel->Height+4+StatusPanel->Height+4;
 MainGrid->Height=newHeight;
 //MainGrid->SetBounds(MainGrid->Left,MainGrid->Top,newWidth,newHeight);
 MoveWindow( Handle,
             (Screen->DesktopWidth-Width)/2,
             (Screen->DesktopHeight-Height)/2,
             Width,
             Height,
             true);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ZoomIn1Click(TObject *Sender)
{
 if(MainGrid->DefaultColWidth<30)
 {
  MainGrid->DefaultColWidth++;
  MainGrid->DefaultRowHeight++;
 }
 resize();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ZoomOut1Click(TObject *Sender)
{
 if(MainGrid->DefaultColWidth>5)
 {
  MainGrid->DefaultColWidth--;
  MainGrid->DefaultRowHeight--;
 }
 resize();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::MainGridDrawCell(TObject *Sender, int ACol,
      int ARow, TRect &Rect, TGridDrawState State)
{
 int tmp;
 int h;
 if(State.Contains(gdFixed))
 {
  if( ACol<MainGrid->FixedCols &&
      ARow>=MainGrid->FixedRows &&
      numX)
  {
   if(headX&&!headX[ARow-MainGrid->FixedRows])
   {
    MainGrid->Canvas->Pen->Width=Rect.Height()/4;
    MainGrid->Canvas->Pen->Color=markshape.Color;
    MainGrid->Canvas->MoveTo(Rect.Left,Rect.Top+Rect.Height()/2);
    MainGrid->Canvas->LineTo(Rect.Right,Rect.Top+Rect.Height()/2);
    MainGrid->Canvas->Pen->Width=1;
   }
   if(tmp=numX [ARow-MainGrid->FixedRows+ACol*sizeY])
   {
    MainGrid->Font->Height=MainGrid->DefaultRowHeight;
    while( (h=MainGrid->Canvas->TextWidth(IntToStr(tmp))) >
           MainGrid->DefaultColWidth &&
           MainGrid->Canvas->Font->Height>1)
     MainGrid->Canvas->Font->Height--;
    MainGrid->Canvas->Brush->Style=bsClear;
    MainGrid->Canvas->TextRect( Rect,(Rect.Left+Rect.Right-h)/2,Rect.Top,
                               IntToStr(tmp));
   }
  }
  else
  if( ACol>=MainGrid->FixedCols &&
      ARow<MainGrid->FixedRows &&
      numY)
  {
   if(headY&&!headY[ACol-MainGrid->FixedCols])
   {
    MainGrid->Canvas->Pen->Width=Rect.Width()/4;
    MainGrid->Canvas->Pen->Color=markshape.Color;
    MainGrid->Canvas->MoveTo(Rect.Left+Rect.Width()/2,Rect.Top);
    MainGrid->Canvas->LineTo(Rect.Left+Rect.Width()/2,Rect.Bottom);
    MainGrid->Canvas->Pen->Width=1;
   }
   if((tmp=numY [ACol-MainGrid->FixedCols+ARow*sizeX]))
   {
    MainGrid->Font->Height=MainGrid->DefaultRowHeight;
    while( (h=MainGrid->Canvas->TextWidth(IntToStr(tmp))) >
          MainGrid->DefaultColWidth &&
          MainGrid->Canvas->Font->Height>1)
     MainGrid->Canvas->Font->Height--;
    MainGrid->Canvas->Brush->Style=bsClear;
    MainGrid->Canvas->TextRect( Rect,(Rect.Left+Rect.Right-h)/2,Rect.Top,
                               IntToStr(tmp));
   }
  }
 }
 else
 {
  if( ACol>=MainGrid->FixedCols &&
      ARow>=MainGrid->FixedRows &&
      picture)
  {
   switch(picture[ ACol-MainGrid->FixedCols +
               (ARow-MainGrid->FixedRows) * sizeX])
   {
    case 1:
     paint(MainGrid->Canvas,Rect);
    break;
    case 2:
     mark(MainGrid->Canvas,Rect);
    break;
    case 0:
     erase(MainGrid->Canvas,Rect);
   }
  }
 }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::paint(TCanvas* Canvas,TRect& Rect)
{
 Canvas->Pen->Color=clBlack;
 Canvas->Brush->Color=paintshape.Color;
 switch(paintshape.Shape)
 {
  case 0:
   Canvas->Ellipse(Rect.Left,Rect.Top,Rect.Right,Rect.Bottom);
  break;
  case 1:
   Canvas->Rectangle(Rect.Left,Rect.Top,Rect.Right,Rect.Bottom);
  break;
  case 2:
  {
   TPoint p[8];
   p[0]=Point(Rect.Left+Rect.Width()/3,Rect.Top);
   p[1]=Point(Rect.Right-Rect.Width()/3,Rect.Top);
   p[2]=Point(Rect.Right,Rect.Top+Rect.Height()/3);
   p[3]=Point(Rect.Right,Rect.Bottom-Rect.Height()/3);
   p[4]=Point(Rect.Right-Rect.Width()/3,Rect.Bottom);
   p[5]=Point(Rect.Left+Rect.Width()/3,Rect.Bottom);
   p[6]=Point(Rect.Left,Rect.Bottom-Rect.Height()/3);
   p[7]=Point(Rect.Left,Rect.Top+Rect.Height()/3);
   Canvas->Polygon(p,7);
  }
  break;
  case 3:
   Canvas->RoundRect( Rect.Left,Rect.Top,Rect.Right,Rect.Bottom,
                      Rect.Width()/2,Rect.Height()/2);
  break;
  case 4:
  {
   int w=Rect.Width()/3;
   Canvas->Pen->Color=paintshape.Color;
   Canvas->Pen->Width=w;
   Canvas->MoveTo(Rect.Left+w/2,Rect.Top+w/2);
   Canvas->LineTo(Rect.Right-w/2,Rect.Bottom-w/2);
   Canvas->MoveTo(Rect.Left+w/2,Rect.Bottom-w/2);
   Canvas->LineTo(Rect.Right-w/2,Rect.Top+w/2);
   Canvas->Pen->Width=1;
  }
  break;
 }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::mark(TCanvas* Canvas,TRect& Rect)
{
 Canvas->Pen->Color=clBlack;
 Canvas->Brush->Color=markshape.Color;
 int r;
 switch(markshape.Shape)
 {
  case 0:
   r=Rect.Width()/3;
   Canvas->Ellipse(Rect.Left+r,Rect.Top+r,Rect.Right-r,Rect.Bottom-r);
  break;
  case 1:
   r=Rect.Width()/4;
   Canvas->Ellipse(Rect.Left+r,Rect.Top+r,Rect.Right-r,Rect.Bottom-r);
  break;
  case 2:
   r=Rect.Width()/4;
   Canvas->Rectangle(Rect.Left+r,Rect.Top+r,Rect.Right-r,Rect.Bottom-r);
  break;
  case 3:
   Canvas->Pen->Color=markshape.Color;
   Canvas->MoveTo(Rect.Left,Rect.Top);
   Canvas->LineTo(Rect.Right,Rect.Bottom);
   Canvas->MoveTo(Rect.Left,Rect.Bottom);
   Canvas->LineTo(Rect.Right,Rect.Top);
  break;
 }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::erase(TCanvas* Canvas,TRect& Rect)
{

}
//---------------------------------------------------------------------------
void __fastcall TForm1::measure(TCanvas* Canvas,TRect& Rect)
{

}
//---------------------------------------------------------------------------
void __fastcall TForm1::Paint2Click(TObject *Sender)
{
 TForm2* Form2 = new TForm2(this);
 Form2->RadioGroup1->ItemIndex=paintshape.Shape;
 Form2->ColorShape->Brush->Color=paintshape.Color;
 if(Form2->ShowModal()==mrOk)
 {
  paintshape.Shape=Form2->RadioGroup1->ItemIndex;
  paintshape.Color=Form2->ColorShape->Brush->Color;
  MainGrid->Invalidate();
 }
 delete Form2;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::MainGridMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
 int Col,Row;
 MainGrid->MouseToCell(X,Y,Col,Row);
 Col-=MainGrid->FixedCols-1;
 Row-=MainGrid->FixedRows-1;
 AnsiString msg;
 if(Col>0) msg=IntToStr(Col);
 msg=msg+":";
 if(Row>0) msg=msg+IntToStr(Row);
 PosLabel->Caption=msg;
 TGridRect Rect;
 Rect=MainGrid->Selection;
 SelectLabel->Caption= IntToStr(Rect.Right-Rect.Left+1)+
                       "x"+
                       IntToStr(Rect.Bottom-Rect.Top+1);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::MainGridMouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
 if(ai) ai->Stop();
 int Col,Row;
 MainGrid->MouseToCell(X,Y,Col,Row);
 if(headX&&Col<MainGrid->FixedCols&&Row>=MainGrid->FixedRows)
 {
  if(headX[Row-MainGrid->FixedRows]&&numX)
  {
   bool ok=true;
   int c=0;
   char pre=0;
   int g=MainGrid->FixedCols-1;
   int i;
   int j=Row-MainGrid->FixedRows;
   for(i=sizeX-1;i>=0;i--)
   {
    if(picture[i+j*sizeX]==1)
     c++;
    if(picture[i+j*sizeX]!=1&&pre==1)
    {
     if(c!=numX[j+g*sizeY])
     {
      ok=false;
      break;
     }
     g--;
     c=0;
    }
    pre=picture[i+j*sizeX];
   }
   if( (pre==1&&g<0) ||
       (g>=0&&c!=numX[j+g*sizeY]) ||
       (g>0&&numX[j+(g-1)*sizeY]>0))
    ok=false;
   if(ok)
   {
    TGridRect Rect;
    Rect.Left=MainGrid->FixedCols;
    Rect.Right=MainGrid->ColCount-1;
    Rect.Top=Row;
    Rect.Bottom=Row;
    MainGrid->Selection=Rect;
    StoreUndo();
    headX[Row-MainGrid->FixedRows]=0;
    for(i=0;i<sizeX;i++)
     if(picture[i+j*sizeX]==0)
     {
      picture[i+j*sizeX]=2;
      InvalidateRect(MainGrid->Handle,&MainGrid->CellRect(i+MainGrid->FixedCols,Row),false);
     }
   }
  }
  else
   headX[Row-MainGrid->FixedRows]=1;
  for(int i=0;i<MainGrid->FixedCols;i++)
   InvalidateRect(MainGrid->Handle,&MainGrid->CellRect(i,Row),false);
 }
 else if(headY&&Col>=MainGrid->FixedCols&&Row<MainGrid->FixedRows)
 {
  if(headY[Col-MainGrid->FixedCols]&&numY)
  {
   bool ok=true;
   int c=0;
   char pre=0;
   int g=MainGrid->FixedRows-1;
   int i=Col-MainGrid->FixedCols;;
   int j;
   for(j=sizeY-1;j>=0;j--)
   {
    if(picture[i+j*sizeX]==1)
     c++;
    if(picture[i+j*sizeX]!=1&&pre==1)
    {
     if(c!=numY[i+g*sizeX])
     {
      ok=false;
      break;
     }
     g--;
     c=0;
    }
    pre=picture[i+j*sizeX];
   }
   if( (pre==1&&g<0) ||
       (g>=0&&c!=numY[i+g*sizeX]) ||
       (g>0&&numY[i+(g-1)*sizeX]>0))
    ok=false;
   if(ok)
   {
    TGridRect Rect;
    Rect.Left=Col;
    Rect.Right=Col;
    Rect.Top=MainGrid->FixedRows;
    Rect.Bottom=MainGrid->RowCount;
    MainGrid->Selection=Rect;
    StoreUndo();
    headY[Col-MainGrid->FixedCols]=0;
    for(j=0;j<sizeY;j++)
     if(picture[i+j*sizeX]==0)
     {
      picture[i+j*sizeX]=2;
      InvalidateRect(MainGrid->Handle,&MainGrid->CellRect(Col,j+MainGrid->FixedRows),false);
     }
   }
  }
  else
  {
   headY[Col-MainGrid->FixedCols]=1;
  }
  for(int j=0;j<MainGrid->FixedRows;j++)
   InvalidateRect(MainGrid->Handle,&MainGrid->CellRect(Col,j),false);
 }
 else if(tool>=0&&Col>=MainGrid->FixedCols&&Row>=MainGrid->FixedRows&&Button==mbLeft&&picture)
 {
  StoreUndo();
  for(int i=MainGrid->Selection.Left;i<=MainGrid->Selection.Right;i++)
   for(int j=MainGrid->Selection.Top;j<=MainGrid->Selection.Bottom;j++)
   {
    picture[i-MainGrid->FixedCols+(j-MainGrid->FixedRows)*sizeX]=tool;
   }
  saved=false; 
  MainGrid->Row=Row;
  MainGrid->Col=Col;
  InvalidateRect(MainGrid->Handle,&MainGrid->CellRect(Col,Row),false);
 }
 else if(Button==mbRight)
 {
  if(Paint1->Checked) {if(Mark1->Enabled) Mark1->Click(); else Erase1->Click();}
  else if(Mark1->Checked) Erase1->Click();
  else if(Erase1->Checked) Measure1->Click();
  else if(Measure1->Checked) Paint1->Click();
 }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Paint1Click(TObject *Sender)
{
 Paint1->Checked=true;
 PaintButton->Down=true;
 tool=1;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Mark1Click(TObject *Sender)
{
 Mark1->Checked=true;
 MarkButton->Down=true;
 tool=2;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Erase1Click(TObject *Sender)
{
 Erase1->Checked=true;
 EraseButton->Down=true;
 tool=0;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Measure1Click(TObject *Sender)
{
 Measure1->Checked=true;
 MeasureButton->Down=true;
 tool=-1;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Mark2Click(TObject *Sender)
{
 TForm2* Form2 = new TForm2(this);
 Form2->Caption="Mark options";
 Form2->RadioGroup1->Items->Clear();
 Form2->RadioGroup1->Items->Append("Point");
 Form2->RadioGroup1->Items->Append("Circle");
 Form2->RadioGroup1->Items->Append("Square");
 Form2->RadioGroup1->Items->Append("Cross");
 Form2->RadioGroup1->ItemIndex=markshape.Shape;
 Form2->ColorShape->Brush->Color=markshape.Color;
 if(Form2->ShowModal()==mrOk)
 {
  markshape.Shape=Form2->RadioGroup1->ItemIndex;
  markshape.Color=Form2->ColorShape->Brush->Color;
  MainGrid->Invalidate();
 }
 delete Form2;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::MainGridKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
 int Col,Row;
 TGridRect Rect;
 Col=MainGrid->Col;
 Row=MainGrid->Row;
 Rect=MainGrid->Selection;
 int i,j;
 AnsiString msg;
 switch(Key)
 {
  case 37:
   if(Col>MainGrid->FixedCols)
   {
    Col--;
    if(Shift.Contains(ssShift))Rect.Left--;
   }
  break;
  case 39:
   if(Col<MainGrid->ColCount-1)
   {
    Col++;
    if(Shift.Contains(ssShift))Rect.Right++;
   }
  break;
  case 38:
   if(Row>MainGrid->FixedRows)
   {
    Row--;
    if(Shift.Contains(ssShift))Rect.Top--;
   }
  break;
  case 40:
   if(Row<MainGrid->RowCount-1)
   {
    Row++;
    if(Shift.Contains(ssShift))Rect.Bottom++;
   }
  break;
 }
 switch(Key)
 {
  case 37: case 38: case 39: case 40:
   Col-=MainGrid->FixedCols-1;
   Row-=MainGrid->FixedRows-1;
   if(Col>0) msg=IntToStr(Col);
   msg=msg+":";
   if(Row>0) msg=msg+IntToStr(Row);
   PosLabel->Caption=msg;
   SelectLabel->Caption= IntToStr(Rect.Right-Rect.Left+1)+
                       "x"+
                       IntToStr(Rect.Bottom-Rect.Top+1);
  break;
  case 13: case 32: case 45:
   if(tool>=0&&Col>=MainGrid->FixedCols&&Row>=MainGrid->FixedRows&&picture)
   {
    StoreUndo();
    for(i=Rect.Left;i<=Rect.Right;i++)
     for(j=Rect.Top;j<=Rect.Bottom;j++)
     {
      picture[i-MainGrid->FixedCols+(j-MainGrid->FixedRows)*sizeX]=tool;
     }
    saved=false;
    //MainGrid->Row=Row;
    //MainGrid->Col=Col;
    Rect.Left=Rect.Right=Col;
    Rect.Top=Rect.Bottom=Row;
    MainGrid->Selection=Rect;
    InvalidateRect(MainGrid->Handle,&MainGrid->CellRect(Col,Row),false);
   }
  break;
 }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Open1Click(TObject *Sender)
{
 if(ai) ai->Stop();
 OpenDialog1->Title="Open saved game";
 OpenDialog1->DefaultExt="jcv";
 OpenDialog1->Filter="Japan Crossword Save (*.jcv)|*.jcv";
 OpenDialog1->InitialDir=".\\save";
 OpenDialog1->FileName=ChangeFileExt(File,".jcv");
 if(OpenDialog1->Execute())
 {
  FILE* f;
  f=fopen(OpenDialog1->FileName.c_str(),"rb");
  if(!f)
  {
   Application->MessageBox("Can't open file","Error",MB_ICONERROR);
   return;
  }
  char id[4];
  fread(id,3,1,f);
  id[3]=0;
  if(strcmp(id,"jcv"))
  {
   Application->MessageBox("Wrong file format","Error",MB_ICONERROR);
   return;
  }
  char tmp;
  fread(&tmp,1,1,f);
  sizeX=tmp;
  fread(&tmp,1,1,f);
  sizeY=tmp;
  if(pattern) delete [] pattern;
  pattern=new char [sizeX*sizeY];
  if(picture) delete [] picture;
  picture=new char [sizeX*sizeY];
  if(headX) delete [] headX;
  headX=new char [sizeY];
  if(headY) delete [] headY;
  headY=new char [sizeX];
  if( !fread(pattern,sizeX*sizeY,1,f) ||
      !fread(picture,sizeX*sizeY,1,f) ||
      !fread(headY,sizeX,1,f) ||
      !fread(headX,sizeY,1,f) )
  {
   Application->MessageBox("Can't read file","Error",MB_ICONERROR);
   return;
  }
  fclose(f);
  makegrid();
  File=ExtractFileName(OpenDialog1->FileName);
  Caption=File+" - Japan Crossword";
  saved=true;
  DeleteUndo();
 }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Save1Click(TObject *Sender)
{
 if(ai) ai->Stop();
 SaveDialog1->Title="Save solution";
 SaveDialog1->DefaultExt="jcv";
 SaveDialog1->Filter="Japan Crossword Save (*.jcv)|*.jcv";
 SaveDialog1->InitialDir=".\\save";
 SaveDialog1->FileName=ChangeFileExt(File,".jcv");
 if(SaveDialog1->Execute())
 {
  FILE* f;
  f=fopen(SaveDialog1->FileName.c_str(),"wb");
  if(!f)
  {
   Application->MessageBox("Can't open file","Error",MB_ICONERROR);
   return;
  }
  char id[4];
  strcpy(id,"jcv");
  fwrite(id,3,1,f);
  char tmp;
  tmp=sizeX;
  fwrite(&tmp,1,1,f);
  tmp=sizeY;
  fwrite(&tmp,1,1,f);
  if( !fwrite(pattern,sizeX*sizeY,1,f) ||
      !fwrite(picture,sizeX*sizeY,1,f) ||
      !fwrite(headY,sizeX,1,f) ||
      !fwrite(headX,sizeY,1,f) )
  {
   Application->MessageBox("Can't write file","Error",MB_ICONERROR);
   return;
  }
  fclose(f);
  File=ExtractFileName(SaveDialog1->FileName);
  Caption=File+" - Japan Crossword";
  saved=true;
  DeleteUndo();
 }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
 if(ai) ai->Stop();
 if(!saved)
  Save1->Click();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Check1Click(TObject *Sender)
{
 if(ai) ai->Stop();
 if(!picture||!pattern) return;
 int i,j;
 bool equal=true;
 for(i=0;i<sizeX&&equal;i++)
  for(j=0;j<sizeY;j++)
  {
   if( (picture[i+j*sizeX]==1&&pattern[i+j*sizeX]!=1) ||
       (pattern[i+j*sizeX]==1&&picture[i+j*sizeX]!=1))
   {
    equal=false;
    break;
   }
  }
 if(equal)
 {
  Application->MessageBox("You find a solution !!!","Congratulations !",MB_ICONEXCLAMATION);
 }
 else
 {
  Application->MessageBox("Your solution is not right.","Unfortunately",MB_ICONERROR);
 }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::PromptButtonClick(TObject *Sender)
{
 Prompt1->Click();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Prompt1Click(TObject *Sender)
{
 if(ai) ai->Stop();
 if(!picture||!pattern) return;
 int i,j,n;
 int c=0;
 for(i=0;i<sizeX;i++)
  for(j=0;j<sizeY;j++)
   if( (picture[i+j*sizeX]==1&&pattern[i+j*sizeX]!=1) ||
       (picture[i+j*sizeX]!=1&&pattern[i+j*sizeX]==1))
    c++;
 if(c==0)
 {
  Application->MessageBox("You find a solution !!!","Nothing to prompting !",MB_ICONEXCLAMATION);
  return;
 }
 n=random(c);
 for(i=0;i<sizeX&&c>n;i++)
  for(j=0;j<sizeY;j++)
  {
   if( (picture[i+j*sizeX]==1&&pattern[i+j*sizeX]!=1) ||
       (picture[i+j*sizeX]!=1&&pattern[i+j*sizeX]==1))
    c--;
   if(c==n)
   {
    if(pattern[i+j*sizeX]) picture[i+j*sizeX]=1;
    else picture[i+j*sizeX]=2;
    InvalidateRect(MainGrid->Handle,&MainGrid->CellRect(i+MainGrid->FixedCols,j+MainGrid->FixedRows),false);
    saved=false;
    break;
   }
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::AI1Click(TObject *Sender)
{
 if(ai) return;
 if(!picture||!numX||!numY) return;
 ButtonPanel->Cursor=crHourGlass;
 MainGrid->Cursor=crHourGlass;
 StatusPanel->Cursor=crHourGlass;
 AIscan(true);
 ButtonPanel->Cursor=crDefault;
 MainGrid->Cursor=crDefault;
 StatusPanel->Cursor=crDefault;
 Application->MessageBox("AI did one scan.","AI stopped",MB_ICONINFORMATION);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::AIButtonClick(TObject *Sender)
{
 AI1->Click();
}
//---------------------------------------------------------------------------
void TForm1::AIscan(bool one)
{
 TForm4* Form4=NULL;
 if(!random(3))
 {
  Form4=new TForm4(this);
  Form4->Show();
 }
 ai=new AI;
 int i,j;
 char *str, *num;
 int pn;
 bool ch;
 str=new char[sizeX>sizeY?sizeX:sizeY];
 num=new char[MainGrid->FixedCols>MainGrid->FixedRows?MainGrid->FixedCols:MainGrid->FixedRows];
 TGridRect Rect;
 TGridRect preRect=MainGrid->Selection;
 Rect.Left=MainGrid->FixedCols;
 Rect.Right=MainGrid->ColCount-1;
 Rect.Top=MainGrid->FixedRows;
 Rect.Bottom=MainGrid->RowCount-1;
 MainGrid->Selection=Rect;
 StoreUndo();
 do
 {
  Rect.Left=MainGrid->FixedCols;
  Rect.Right=MainGrid->ColCount-1;
  Rect.Top=Rect.Bottom=MainGrid->FixedRows;
  ch=false;
  for(j=0;j<sizeY;j++)
  {
   MainGrid->Selection=Rect;
   Application->ProcessMessages();
   for(i=0;i<sizeX;i++)
    str[i]=picture[i+j*sizeX];
   pn=0;
   for(i=0;i<MainGrid->FixedCols;i++)
    if(numX[j+i*sizeY])
    {
     num[pn]=numX[j+i*sizeY];
     pn++;
    }
   if(ai->Solve(str,sizeX,num,pn))
   {
    ch=true;
    saved=false;
    for(i=0;i<sizeX;i++)
    {
     picture[i+j*sizeX]=str[i];
     InvalidateRect(MainGrid->Handle,&MainGrid->CellRect(i+MainGrid->FixedCols,j+MainGrid->FixedRows),false);
    }
   }
   Rect.Top++;
   Rect.Bottom++;
  }
  Rect.Left=Rect.Right=MainGrid->FixedCols;
  Rect.Bottom=MainGrid->RowCount-1;
  Rect.Top=MainGrid->FixedRows;
  for(i=0;i<sizeX;i++)
  {
   MainGrid->Selection=Rect;
   Application->ProcessMessages();
   for(j=0;j<sizeY;j++)
    str[j]=picture[i+j*sizeX];
   pn=0;
   for(j=0;j<MainGrid->FixedRows;j++)
    if(numY[i+j*sizeX])
    {
     num[pn]=numY[i+j*sizeX];
     pn++;
    }
   if(ai->Solve(str,sizeY,num,pn))
   {
    ch=true;
    saved=false;
    for(j=0;j<sizeY;j++)
    {
     picture[i+j*sizeX]=str[j];
     InvalidateRect(MainGrid->Handle,&MainGrid->CellRect(i+MainGrid->FixedCols,j+MainGrid->FixedRows),false);
    }
   }
   Rect.Left++;
   Rect.Right++;
  }
 }
 while(ch&&!one);
 delete [] num;
 delete [] str;
 delete ai;
 ai=NULL;
 MainGrid->Selection=preRect;
 if(Form4) delete Form4;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::AItotalscan1Click(TObject *Sender)
{
 if(ai) return;
 if(!picture||!numX||!numY) return;
 ButtonPanel->Cursor=crHourGlass;
 MainGrid->Cursor=crHourGlass;
 StatusPanel->Cursor=crHourGlass;
 AIscan(false);
 ButtonPanel->Cursor=crDefault;
 MainGrid->Cursor=crDefault;
 StatusPanel->Cursor=crDefault;
 Application->MessageBox("AI did one's best.","AI stopped",MB_ICONINFORMATION);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::About1Click(TObject *Sender)
{
 Application->MessageBox("Japan Crossword\n\
\xa9 Gelin, 2002 (den-gelin.narod.ru)\n\
\xa9 Gunn Soft, 1998-2000 (www.puzzle.kiev.ua)\n\
Based on Gunn's Japanese Puzzle 2000.\n\
Tools (Measure tool) and AI (Artificial Intelligence) added.\n\
Skins support and other beauty deleted.\n\
 _ \t   \t \t.\t\n\
|  \t _ \t|\t \t _\n\
|. \t|_|\t|\t|\t| |\n\
|_|\t|_ \t|\t|\t| |\n\n\
This software is absolutely freeware\n\
and it is distributed as it is.\
","About Japan Crossword",MB_ICONINFORMATION);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Rules1Click(TObject *Sender)
{
 ShellExecute(NULL,NULL,".\\help\\index.htm",NULL,"",SW_SHOWNORMAL);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::AppIdle(TObject *Sender, bool &Done)
{
 Save1->Enabled=!saved&&picture&&pattern&&headX&&headY;
 SaveButton->Enabled=!saved&&picture&&pattern&&headX&&headY;
 MainGrid->Enabled=picture;
 Check1->Enabled=picture&&pattern;
 CheckButton->Enabled=picture&&pattern;
 Prompt1->Enabled=picture&&pattern;
 PromptButton->Enabled=picture&&pattern;
 AI1->Enabled=picture&&pattern&&numX&&numY&&!ai;
 AIButton->Enabled=picture&&pattern&&numX&&numY&&!ai;
 AItotalscan1->Enabled=picture&&pattern&&numX&&numY&&!ai;
 Undo1->Enabled=undoBuf;
 Saveasnew1->Enabled=picture;
 Adjust1->Enabled=picture&&!pattern;
 Mark1->Enabled=picture&&pattern;
 MarkButton->Enabled=picture&&pattern;
 Paint1->Enabled=picture;
 PaintButton->Enabled=picture;
 Erase1->Enabled=picture;
 EraseButton->Enabled=picture;
 Measure1->Enabled=picture;
 MeasureButton->Enabled=picture;
 Done=true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Undo1Click(TObject *Sender)
{
 Undo();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::StoreUndo()
{
 if(!picture) return;
 undoRect=MainGrid->Selection;
 int W=undoRect.Right-undoRect.Left+1;
 int H=undoRect.Bottom-undoRect.Top+1;
 if(undoBuf) delete [] undoBuf;
 undoBuf=new char[W*H];
 int i,j;
 for(i=0;i<W;i++)
  for(j=0;j<H;j++)
  {
   undoBuf[i+j*W]=picture[i+undoRect.Left-MainGrid->FixedCols+(j+undoRect.Top-MainGrid->FixedRows)*sizeX];
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Undo()
{
 if(!picture||!undoBuf) return;
 MainGrid->Selection=undoRect;
 char tmp;
 int W=undoRect.Right-undoRect.Left+1;
 int H=undoRect.Bottom-undoRect.Top+1;
 int i,j;
 for(i=0;i<W;i++)
  for(j=0;j<H;j++)
  {
   tmp=picture[i+undoRect.Left-MainGrid->FixedCols+(j+undoRect.Top-MainGrid->FixedRows)*sizeX];
   picture[i+undoRect.Left-MainGrid->FixedCols+(j+undoRect.Top-MainGrid->FixedRows)*sizeX]=undoBuf[i+j*W];
   undoBuf[i+j*W]=tmp;
   InvalidateRect(MainGrid->Handle,&MainGrid->CellRect(i+undoRect.Left,j+undoRect.Top),false);
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::DeleteUndo()
{
 if(undoBuf) delete [] undoBuf;
 undoBuf=NULL;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Saveasnew1Click(TObject *Sender)
{
 if(ai) ai->Stop();
 SaveDialog1->Title="Save game as new game";
 SaveDialog1->DefaultExt="jc";
 SaveDialog1->Filter="Japan Crossword (*.jc)|*.jc";
 SaveDialog1->InitialDir=".\\games";
 SaveDialog1->FileName=ChangeFileExt(File,".jc");
 if(SaveDialog1->Execute())
 {
  FILE* f;
  f=fopen(SaveDialog1->FileName.c_str(),"wb");
  if(!f)
  {
   Application->MessageBox("Can't open file","Error",MB_ICONERROR);
   return;
  }
  char id[5];
  strcpy(id,"\x03JCS");
  fwrite(id,4,1,f);
  short tmp;
  tmp=sizeX;
  fwrite(&tmp,2,1,f);
  tmp=sizeY;
  fwrite(&tmp,2,1,f);
  for(int j=0;j<sizeY;j++)
   for(int i=0;i<sizeX;i++)
   {
    char c;
    if(picture[i+j*sizeX]==1)
     c=1;
    else
     c=0;
    if( !fwrite(&c,1,1,f) )
    {
     Application->MessageBox("Can't write file","Error",MB_ICONERROR);
     return;
    }
   }
  fclose(f);
  File=ExtractFileName(SaveDialog1->FileName);
  Caption=File+" - Japan Crossword";
 }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::New2Click(TObject *Sender)
{
 TForm5* Form5=new TForm5(this);
 Form5->GroupBox2->Hide();
 Form5->ClientHeight=Form5->ClientHeight-Form5->GroupBox2->Height;
 if(Form5->ShowModal()==mrOk)
 {
  sizeX=Form5->UpDown1->Position;
  sizeY=Form5->UpDown2->Position;
  if(picture) delete [] picture;
  picture=new char[sizeX*sizeY];
  memset(picture,0,sizeX*sizeY);
  if(pattern) delete [] pattern;
  pattern=NULL;
  if(headX) delete [] headX;
  headX=NULL;
  if(headY) delete [] headY;
  headY=NULL;
  if(numX) delete [] numX;
  numX=NULL;
  if(numY) delete [] numY;
  numY=NULL;
  MainGrid->FixedCols=0;
  MainGrid->FixedRows=0;
  MainGrid->ColCount=sizeX;
  MainGrid->RowCount=sizeY;
  SizeLabel->Caption=IntToStr(sizeX)+"x"+IntToStr(sizeX);
  File="new.jc";
  Caption=File+" - Japan Crossword";
  resize();
  MainGrid->Invalidate();
  DeleteUndo();
 }
 delete Form5;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Openforediting1Click(TObject *Sender)
{
 New1->Click();
 if(pattern&&picture)
 {
  memcpy(picture,pattern,sizeX*sizeY);
  if(pattern) delete [] pattern;
  pattern=NULL;
  if(headX) delete [] headX;
  headX=NULL;
  if(headY) delete [] headY;
  headY=NULL;
  if(numX) delete [] numX;
  numX=NULL;
  if(numY) delete [] numY;
  numY=NULL;
  MainGrid->FixedCols=0;
  MainGrid->FixedRows=0;
  MainGrid->ColCount=sizeX;
  MainGrid->RowCount=sizeY;
  resize();
  MainGrid->Invalidate();
 }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Adjust1Click(TObject *Sender)
{
 if(!picture) return;
 TForm5* Form5=new TForm5(this);
 Form5->CancelButton->Hide();
 Form5->OkButton->Left=Form5->OkButton->Left+Form5->CancelButton->Width/2+7;
 Form5->UpDown1->Position=sizeX;
 Form5->UpDown2->Position=sizeY;
 if(Form5->ShowModal()==mrOk&&(Form5->UpDown1->Position!=sizeX||Form5->UpDown2->Position!=sizeY))
 {
  int oldsizeX=sizeX;
  int oldsizeY=sizeY;
  sizeX=Form5->UpDown1->Position;
  sizeY=Form5->UpDown2->Position;
  char* tmp=new char[oldsizeX*oldsizeY];
  memcpy(tmp,picture,oldsizeX*oldsizeY);
  delete [] picture;
  picture=new char[sizeX*sizeY];
  memset(picture,0,sizeX*sizeY);
  for(int j=0;j<(sizeY<oldsizeY?sizeY:oldsizeY);j++)
   memcpy(picture+j*sizeX,tmp+j*oldsizeX,sizeX<oldsizeX?sizeX:oldsizeX);
  MainGrid->ColCount=MainGrid->ColCount+sizeX-oldsizeX;
  MainGrid->RowCount=MainGrid->RowCount+sizeY-oldsizeY;
  SizeLabel->Caption=IntToStr(sizeX)+"x"+IntToStr(sizeY);
  DeleteUndo();
  resize();
  MainGrid->Invalidate();
 }
}
//---------------------------------------------------------------------------

